



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>进程 &amp; 线程相关知识</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">进程 &amp; 线程相关知识</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 23:47:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>不管Java，C++都有进程、线程相关的内容。在这里统一整理吧。</p>
<p>Python的线程，其实是伪线程，不能真正的并发。下面也有讲。</p>
<p>线程自己基本上不拥有系统资源,只拥有一点在运行中必不可少的资源(如程序计数器,一组寄存器和栈)。</p>
<p>多个线程共享内存。</p>
<p>参考了这篇文章：<a href="http://www.cnblogs.com/qiaoconglovelife/p/5319779.html" rel="external nofollow noreferrer">http://www.cnblogs.com/qiaoconglovelife/p/5319779.html</a></p>
<ul><li><h4>进程与PCB</h4></li></ul>
<p>　　　　<strong>进程</strong>：进程是程序的一次执行过程，是系统进行资源分配和调度的一个独立单位。</p>
<p>　　　　<strong>进程实体（进程映像）</strong>：由程序段、相关数据段和PCB三部分构成。进程是动态的，进程实体是静态的。</p>
<p>　　　　<strong>PCB（进程控制块）</strong>：系统利用PCB来描述进程的基本情况和运行状态，进而控制和管理进程；所谓创建进程，实际上是创建进程映像中的PCB；PCB是进程存在的唯一标志。</p>
<p>进程有5种状态，其中前3种是基本状态：</p>
<p>运行态、就绪态、阻塞态（等待态）。另两种是<strong>新建态</strong>和<strong>终止态。</strong></p>
<ul><li><h4>进程的创建过程</h4></li></ul>
<p>　　　　（1）分配ID与PCB：为新进程分配一个唯一的进程标识号，并申请一个空白的PCB（PCB是有限的）。若PCB申请失败则创建失败。</p>
<p>　　　　（2）分配资源：为新进程的程序和数据、以及用户栈分配必要的内存空间（在PCB 中体现）。注意：这里如果资源不足（比如内存空间），并不是创建失败，而是处于阻塞态。</p>
<p>　　　　（3）初始化PCB：主要初始化（1）标志信息（2）处理机状态信息（3）处理机控制信息，以及（4）设置进程的优先级等。</p>
<p>　　　　（4）调度：如果进程就绪队列能够接纳新进程，就将新进程插入到就绪队列，等待被调度运行。</p>
<p>　　　　注意，进程的创建是一个原子操作，执行期间不允许中断，它是一个不可分割的基本单位。</p>
<ul><li><h4>进程的终止</h4></li></ul>
<p>　　　　引起进程终止的事件主要有：</p>
<p>　　　　（1）正常结束</p>
<p>　　　　（2）异常结束：如存储区越界、非法指令、I/O故障等</p>
<p>　　　　（3）外界干预：如操作员或操作系统干预、父进程请求、父进程终止。</p>
<p>　　　　操作系统终止进程的过程如下：</p>
<p>　　　　（1）根据被终止进程的ID，检索PCB，从中读出该进程的状态</p>
<p>　　　　（2）若被终止进程处于执行状态，立即终止该进程的执行，将处理机资源分配给其他进程</p>
<p>　　　　（3）若该进程还有子进程，则应将其所有的子进程终止</p>
<p>　　　　（4）将该进程所拥有的资源，或归还给其父进程或归还给操作系统</p>
<p>　　　　（5）将该PCB从所在队列（链表）中删除。</p>
<ul><li><h4><strong>进程之间的切换</strong></h4></li></ul>
<p>　　　　（1）保存处理机上下文，包括程序计数器和其他寄存器。</p>
<p>　　　　（2）更新PCB信息。</p>
<p>　　　　（3）把进程的PCB移入相应的队列，如就绪、在某事件阻塞等队列。</p>
<p>　　　　（4）选择另一个进程执行，并更新其PCB。</p>
<p>　　　　（5）更新内存管理的数据结构。</p>
<p>　　　　（6）恢复处理机上下文。</p>
<p>　　　　注意：&ldquo;调度&rdquo;和&ldquo;切换&rdquo;的区别：调度是指决定资源分配给哪个进程的行为，是一种决策行为；切换是指实际分配的行为，是执行行为。一般来说，等有资源的调度，再有进程的切换。</p>
<ul><li><h4>线程</h4></li></ul>
<p>　　　　线程是轻量化的进程，是程序执行流的最小单位；由线程ID、程序计数器、寄存器集合和堆栈组成；线程自己不拥有系统资源，只拥有一点在运行中必不可少的资源，但它可与同属一个进程的其他线程共享进程所拥有的全部资源。</p>
<ul><li><h4>进程与线程区别</h4></li></ul>
<p>　　　　（1）一个程序至少有一个进程,一个进程至少有一个线程。线程(Thread)是进程的一个实体，是CPU调度和分派的基本单位；</p>
<p>　　　　（2）进程拥有独立的内存单元，而多个线程共享内存。从而线程效率更高；</p>
<p>　　　　（3）进程有独立的地址空间，一个进程崩溃后，在保护模式下不会对其它进程产生影响，而线程没有单独的地址空间，一个线程死掉就等于整个进程死掉，所以多进程的程序要比多线程的程序健壮；</p>
<p>　　　　（4）进程切换时，耗费资源较大，效率要差一些；</p>
<p>　　　　（5）进程是系统资源分配的基本单位，线程是调度的基本单位。</p>
<h4>线程独有的内容：线程上下文，包括线程ID、栈、栈指针、PC（程序计数器）、通用目的寄存器、条件码。</h4>
<h4>线程共享的内容：<strong>文件描述符和整个用户虚拟地址空间，包括只读文本（代码）、静态变量、堆、所有的共享库代码和数据区域组成。</strong></h4>
<ul><li><h4>相比进程，线程有什么好处</h4></li></ul>
<p>　　　　（1）易于调度。</p>
<p>　　　　（2）提高并发性。通过线程可方便有效地实现并发性。进程可创建多个线程来执行同一程序的不同部分。</p>
<p>　　　　（3）开销少。创建线程比创建进程要快，所需开销很少。。</p>
<p>　　　　（4）利于充分发挥多处理器的功能。</p>
<ul><li><h4>相比进程，线程有什么缺点</h4></li></ul>
<p>　　　　（1）线程之间的同步和加锁控制比较麻烦</p>
<p>　　　　（2）一个线程的崩溃影响到整个程序的稳定性</p>
<p>　　　　（3）线程多了之后，线程本身的调度也是一个麻烦事儿，需要消耗较多的CPU</p>
<ul><li><h4>分离线程</h4>
<ul><li>线程可以是可结合的，或者是可分离的；</li>
<li>可结合的线程能够被其他线程收回其资源和杀死。在被其他线程回收之前，它的存储器资源（例如栈）是没有被释放的，相反一个分离的线程是不能被其他线程回收或杀死的。它的存储器资源在它终止时由系统自动释放；</li>
<li>为避免存储器泄漏，每个可结合线程都应该被其他线程显式地收回，要么通过调用pthread_detach函数被分离；(对应于Java就是 Thread.join和Thread.detach )</li>
<li>默认情况下，线程被创建成可结合的。(注意：可结合是一种状态，要调用join方法来进行结合/释放)</li></ul></li></ul>
<p>来一个例子：</p>
<div>
<pre class="prettyprint linenums">package com.company;

import static java.lang.Thread.sleep;

class Solution {

}

class MyRunnable implements Runnable {

    int x = 5;<br />
    @Override<br />
    public void run() {<br />
        synchronized(this) {<br />
            for (int i = 0; i &lt; 5; i++) {<br />
                System.out.println("hi " + Thread.currentThread().getName() + ":" + x--);<br />
            }<br />
        }<br />
        System.out.println("here to sleep");<br />
        try {<br />
            sleep(5000);<br />
        } catch (InterruptedException e) {<br />
            e.printStackTrace();<br />
        }<br />
    }<br />
}

public class Main {

    public static void main(String[] args) throws InterruptedException {

        MyRunnable mr = new MyRunnable();<br />
        Thread t1 = new Thread(mr, "1");<br />
        Thread t2 = new Thread(mr, "2");<br />
        Thread t3 = new Thread(mr, "3");

        t1.start();<br />
        t2.start();<br />
        t3.start();

        System.out.println();

    }

}</pre>
</div>
<p>打印结果：</p>
<div>
<pre class="prettyprint linenums">hi 1:5<br />
hi 1:4<br />
hi 1:3<br />
hi 1:2<br />
hi 1:1<br />
here to sleep<br />
hi 3:0<br />
hi 3:-1<br />
hi 3:-2<br />
hi 3:-3<br />
hi 3:-4<br />
here to sleep

hi 2:-5<br />
hi 2:-6<br />
hi 2:-7<br />
hi 2:-8<br />
hi 2:-9<br />
here to sleep</pre>
</div>
<p>三个线程，同时sleep了5秒钟，然后整个程序才结束。</p>
<p>如果synchronized加在函数上，那么是每个线程分别sleep 5秒钟，一共sleep 15秒钟。</p>
<ul><li><h4>IPC方式（进程间通信方式）</h4></li></ul>
<p>　　　　（1）管道：半双工；用于父子、兄弟之间。</p>
<p>　　　　（2）命名管道（FIFO）</p>
<p>　　　　（2）消息队列：消息链表存于内核，每个消息队列由消息队列标识符标识；于管道不同的是，消息队列存放在内核中，只有在内核重启时才能删除一个消息队列；消息队列的大小受限制。</p>
<p>　　　　（3）信号量（semophore）：常用来处理临界资源的访问同步问题。临界资源：为某一时刻只能由一个进程或线程操作的资源。</p>
<p>　　　　（4）共享内存：可以说是最有用的进程间通信方式，也是最快的IPC形式。</p>
<p>　　　　（5）套接字：也可用于不同机器之间。</p>
<p>　　　　（6）信号（Signal）</p>
<ul><li><h4>线程同步方式</h4></li></ul>
<p>　　　　（1）临界区：当多个线程访问一个独占性共享资源时，可以使用临界区对象。拥有临界区的线程可以访问被保护起来的资源或代码段，其他线程若想访问，则被挂起，直到拥有临界区的线程放弃临界区为止。</p>
<p>（注：Java的synchronized代码段，也勉强可以算作临界区，只是语言标记互斥的实现方式；要访问代码段，需要获得传给synchronized的Object这个对象的锁。注意，<strong>每个java对象都隐含有一把锁</strong>。</p>
<p>Java GC需要的safe point，为了让多个线程都停下来，标记的区域-其他线程不进来，里面的线程出来了，就开始GC- 跟临界区的思想也有一点像）</p>
<p>　　　　（2）互斥量-mutex：互斥对象和临界区对象非常相似，只是其允许在进程间使用，而临界区只限制与同一进程的各个线程之间使用。</p>
<p>　　　　（3）条件变量：一个线程被挂起，直到某件事件发生。</p>
<p>　　　　（4）信号量：当需要一个计数器来限制可以使用某共享资源的线程数目时，可以使用&ldquo;信号量&rdquo;对象。CSemaphore类对象保存了对当前访问某一个指定资源的线程的计数值，该计数值是当前还可以使用该资源的线程数目。如果这个计数达到了零，则所有对这个CSemaphore类对象所控制的资源的访问尝试都被放入到一个队列中等待，直到超时或计数值不为零为止。</p>
<p>　　　　（5）事件：允许一个线程在处理完一个任务后，主动唤醒另外一个线程执行任务。</p>
<p>　　　　（6）套接字</p>
<p>感觉上面这篇文章不错，有一定深度。可以多看看这个博客：<a href="http://www.cnblogs.com/qiaoconglovelife/" rel="external nofollow noreferrer">http://www.cnblogs.com/qiaoconglovelife/</a></p>
<h2>再来聊一下Python的线程</h2>
<p>简单地说就是作为可能是仅有的支持多线程的解释型语言（perl的多线程是残疾，PHP没有多线程），Python的多线程是有compromise的，在任意时间只有一个Python解释器在解释Python bytecode。Ruby也是有thread支持的，而且至少Ruby MRI是有GIL的。</p>
<p>单独开了一篇文章来写，详细内容可以看这篇文章：<a href="http://www.cnblogs.com/charlesblc/p/6135819.html" rel="external nofollow noreferrer">http://www.cnblogs.com/charlesblc/p/6135819.html</a></p>
<div>
<h2>看一下Javascript里面的线程</h2>
<p>JavaScript引擎是单线程运行的,浏览器无论在什么时候都只且只有一个线程在运行JavaScript程序.&nbsp;&nbsp;详细学习见这篇文章：</p></div>
<div><a href="http://www.cnblogs.com/charlesblc/p/6136841.html" rel="external nofollow noreferrer">http://www.cnblogs.com/charlesblc/p/6136841.html</a></div>
<div>&nbsp;</div>
<div>&nbsp;</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qyrjgd8.html">javadoc 生成自定义的标签</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4v7oeq.html">5、android ConnectivityManager获取网络状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93zlk0q.html">ssh框架搭建错误集合</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw6e3l9.html">多个div 一行显示的处理方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnn156q.html">string字符串类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmww7k9.html">Object-C基础学习笔记（1）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2r209.html">SpringMVC中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7oroq.html">GraphLab&colon;新的面向机器学习的并行框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zdmx09.html">javascript的一个简易利率计算器&plus;js图像显示 代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkzz3d8.html">leaflet  利用ajax 将前端地图上的数据post到后台</a>
		</li>
						<li><a href="https://www.batexi.com/a/96prkpv8.html">第二周Python学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rj3228.html">sparkSQL将谓词推入kudu引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjg0549.html">HTML5 元素属性介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv060j8.html">ESXi虚拟机开机进入bios的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2pogx9.html">【NIO】Java NIO之缓冲</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r52vmeq.html">Ubuntu 16 修改时区！</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwz4zy8.html">java解决共享资源竞争</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjyxzo8.html">linux命令 zcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pwpreq.html">MongoDB入门教程二［MongoDB Shell 简介与使用］</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlm4xy9.html">由python的math&period;log想到的问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8k1067j9.html">python-django 模型model字段类型说明</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xrkm08.html">n条直线最多能将一个平面分成多少部分？</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm1v579.html">Memcached缓存瓶颈分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0j4xgq.html">Uva 10305 给任务排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4ygow5q.html">mysql 导入导出的几个常用参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zm7369.html">SQL Server中常用的SQL语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zm1r09.html">转 Android学习笔记： 学习过程中碰到的一些问题及解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xr4rv8.html">命名空间std引用&amp;lt&semi;iostream&amp;gt&semi;时使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v7zp38.html">Web的Ajax应用开发模式（一）&mdash;&mdash;了解Ajax的使用形式</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oknz7l9.html">Outlook 无法更新全球通讯簿，错误 0&amp;&num;215&semi;80190194</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
